/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is LightSMS.
 *
 * The Initial Developer of the Original Code is
 * Byungwook Kang.
 * Portions created by the Initial Developer are Copyright (C) 2007
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function light_sms_ui(){
}

light_sms_ui.prototype = {
  onClick : function(aEvent) {
    if (aEvent && aEvent.button == 0 ){
      this.openPopup("chrome://lightsms/content/main.xul", "lightsms");
    }
  },
  onContextMenu : function() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService);
    var branch = prefService.getBranch("browser.preferences.");
    branch.QueryInterface(Components.interfaces.nsIPrefBranch2);
    var instantApply= branch.getBoolPref("instantApply");
    var features = "chrome,titlebar,toolbar,centerscreen" + (instantApply ? ",dialog=no" : ",modal");
    window.openDialog("chrome://lightsms/content/pref.xul", "lightsms-pref", features);
  },
  openPopup: function (url,name) {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
             .getService(Components.interfaces.nsIWindowMediator);
    var enm = wm.getEnumerator(null);
    while(enm.hasMoreElements()){
      var chromeWin=enm.getNext();
      if(chromeWin.name==name){
        chromeWin.focus();
        return;
      }
    }
    //not found
    window.open(url,name,"chrome,titlebar,centerscreen,resizable=no");
  }
};
/***********************************************************
LightSMSListener implementation
***********************************************************/
light_sms_ui.prototype.onStateChange = function(aID,aData){
  if(!document||!document.getElementById("lightsms-statusbar"))return;
  switch(aID){
  case Components.interfaces.nsILightSMS.ST_LOGIN:
    document.getElementById("lightsms-statusbar-icon").src="chrome://lightsms/content/sms"+(aData==Components.interfaces.nsILightSMS.RS_SUCC?"":"0")+".png";
    break;
  }
}


light_sms_ui.prototype.onload = function() {
  if (document&&document.getElementById("lightsms-statusbar")) {
    try {
      gLightSMS_UI.nsILightSMS = Components.classes["@mozilla.org/LightSMS;1"]
                                                  .getService(Components.interfaces.nsILightSMS);
      gLightSMS_UI.nsILightSMS.addListener(gLightSMS_UI);
    } catch (e){}
  }
  window.removeEventListener("load", gLightSMS_UI.onload, false);
}

light_sms_ui.prototype.onunload = function() {
  // remove the listener
  if (gLightSMS_UI.nsILightSMS)gLightSMS_UI.nsILightSMS.removeListener(gLightSMS_UI);
  gLightSMS_UI = null;
}

var gLightSMS_UI = new light_sms_ui();
window.addEventListener("load", gLightSMS_UI.onload, false);
window.addEventListener("unload", gLightSMS_UI.onunload, false);
